/*
 * (C) Copyright 2005
 * Wolfgang Denk, DENX Software Engineering, wd@denx.de.
 *
 * See file CREDITS for list of people who contributed to this
 * project.
 *
 * This program is free software; you can redistribute it and/or
 * modify it under the terms of the GNU General Public License as
 * published by the Free Software Foundation; either version 2 of
 * the License, or (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place, Suite 330, Boston,
 * MA 02111-1307 USA
 */

#include <common.h>
#include <command.h>
#include <s3c2440.h>

int do_led (cmd_tbl_t *cmdtp, int flag, int argc, char *argv[])
{
	int i;

        if(argc > 1)
        goto out_help;

	printf("===================================\n");
	printf("[LED] start test\n");
	printf("[LED] switching led on\n");
	led(1);
	udelay(5000000);
	for (i=0;i<100000000;i++) ;
	printf("[LED] switching led off\n");
	led(0);
	printf("[LED] end test\n");
	printf("EOF\n");
	printf("===================================\n");

        return 0;

out_help:
        printf ("Usage:\n%s\n", cmdtp->usage);
        return 1;	
}

int led (int flag)
{
	
        if (flag) {
                mww(0x56000014, 0x207);
        } else {
                mww(0x56000014, 0x200);
        }
	
	return 0;
}

/***************************************************/

U_BOOT_CMD(
	led,    CFG_MAXARGS,      1,      do_led,
        "led     - led on/off\n",

);

